function img=edgeawared(img,sup)

if nargin==1
  sup=[3 1]; % support of filter
end
  
if size(img,3)==1 % grayscale
  for wid=sup
    for c1=1:size(img,1)   
      img(c1,:)=ji1edgeaware(wid,img(c1,:));
    end
    for c1=1:size(img,2)   
      img(:,c1)=ji1edgeaware(wid,img(:,c1)')';
    end
  end
else % rgb color, etc.
  for wid=sup
    for c1=1:size(img,1)
      dom=ji1domain(img(c1,:,:));
      for c3=1:size(img,3)
        img(c1,:,c3)=ji1edgeaware(wid,img(c1,:,c3),dom);
      end
    end
    for c1=1:size(img,2)   
      dom=ji1domain(img(:,c1,:));
      for c3=1:size(img,3)
        img(:,c1,c3)=ji1edgeaware(wid,img(:,c1,c3)',dom)';
      end
    end
  end  
end

function dom=ji1domain(sig)
  sz=size(sig);
  sz(find(sz==1))=[]; % TODO this is dangerous
  sig=reshape(sig,sz)';
  dom=cumsum(1+sum(abs([zeros(sz(2),1) diff(sig,1,2)]),1));

function res=ji1edgeaware(w,sig,dom)
  if nargin==2
    dom=cumsum(1+[0 abs(diff(sig))]);
  end
  dom(end)=ceil(dom(end)); % small error happens here
  smp=1:dom(end);
  itr=interp1(dom,sig,smp);  
  res=interp1(smp,ji1filter(w,itr),dom);

function res=ji1filter(w,sig)
  w=2*w+1;
  x=linspace(-2,2,w);        % TODO undesirable to repeat
  fil=sqrt(1/pi)*exp(-x.*x); % TODO undesirable to repeat
  fil=fil/sum(fil);          % TODO undesirable to repeat
  num=numel(sig);
  f_sig=fft(sig);
  f_fil=fft(fil,num);  
  res=ifft(f_sig.*f_fil);
  res=real(res);    
  res=res([(w+1)/2:end 1:(w-1)/2]); % rotate  
